<html><head><title>Homework: Files and Disk I/O</title> <link rel="stylesheet" href="homework.css" type="text/css" /></head><body><h1>Homework: Files and Disk I/O</h1>Read: readi, writei, fileread, filewrite, create, and dirlink, and code related to these calls in fs.c, bio.c, ide.c, file.c, and sysfile.c. For now you can ignore log.c (except for the modification explained below); whenever you see "log_write" you should pretend that log_write just calls bwrite with the same arguments.<h2>Hand-In Procedure</h2>You are to turn in this homework during lecture. Please write up your answers to the exercises below and hand them in to a 6.828 staff member at the beginning of lecture.<h2>File and Disk I/O</h2>Insert a print statement in log_write (in log.c) so that you get a print every time a block is written to disk:<pre>
  cprintf("log_write sector %d\n", b->sector);
</pre>Build and boot a new kernel and run these three commands at the shell:<pre>
  echo &gt; a
  echo x &gt; a
  rm a
  mkdir d
</pre>(Try <tt>rm d</tt> if you are curious; it should look much the same as <tt>rm a</tt>.)<p>You should see a sequence of log_write prints after running each command.</p><div class="question"><p><b>Submit</b>: Record the list and annotate it with the calling function and what block is being written (for example, "file's i-node block", "file's data block", &amp;c).</p></div><p>Hint: an easy way to get the name of the calling function is to add a string argument to log_write, edit all the calls to log_write to pass the name of the calling function, and just print it. You should be able to reason about what kind of block is being written just from the calling function.</p><p>You need not write the following up, but try to understand why each write is happening. This will help your understanding of the file system layout and the code.</p></body>